<template>
  <bh-types-filter-ui
    :types="types"
    :selected="selected"
    @changed="onChanged"
  />
</template>

<script>
export default {
  name: 'BhTypesFilter',
  // fetchOnServer: process.env.NODE_ENV !== 'development',
  data: () => ({
    typeList: [],
  }),
  async fetch() {
    try {
      this.typeList = await this.$dataService.getTypes();
    } catch (error) {
      const query = { mid: 'types.fetch.error' };

      if (process.server) {
        this.$nuxt.context.redirect('/server-error', query);
      }
      if (process.client) {
        this.$router.push({ path: '/server-error', query });
      }
    }
  },
  computed: {
    active() {
      return this.$store.getters['filters/getActiveTypes'];
    },
    types() {
      return this.typeList.map((type) => ({
        ...type,
        disabled: !this.active.has(type.code),
      }));
    },
    selected() {
      const selected = this.$store.getters['filters/getSelectedTypes'];
      return this.types.filter((type) => selected.includes(type.code));
    },
  },
  methods: {
    onChanged(selectedTypes) {
      const selected = selectedTypes.map(({ code }) => code);
      this.$store.dispatch('filters/setSelectedTypes', selected);
      this.$emit('changed');
    },
  },
};
</script>
